"
" NOTE: This does not properly handle types with
"  	dots in them like
"
" 	private class.type foo;
"
" We could fix it but for this demonstration the regular
" expression are already nasty enough
"
:function! Getter()
:    " Get the line defining the variable
:    let l:var_line = getline('.')
:    let l:prot = substitute(l:var_line, '\v^\W*(\w+)\W+.*$', '\1', '')
:    let l:type = substitute(l:var_line, '\v^\W*\w+\W+(\w+)\W+.*$', '\1', '')
:    let l:var  = substitute(l:var_line, '\v^\W*\w+\W+\w+\W+(\w+).*', '\1', '')
:    if ((l:prot != 'public') && (l:prot != 'private') && (l:prot != 'protected'))
:        throw "ERROR: Unable to parse variable line"
:    endif
:    " Move cursor back to the class keyword
:    if (search('class', 'b') == 0) 
:        throw "ERROR: Could not find class line"
:    endif
:    " Move cursor forward to the { after the class
:    if (search('{', '') == 0) 
:        throw "ERROR: Could not find class line"
:    endif
"    Go to matching {
     %
:    let l:fun_name = substitute(l:var, '.*', '\u&', '')
:    let l:getter = ["     /**",
\                    "      * Get the current value of ".l:var,
\		     "      *",
\		     "      * @returns ".l:var,
\		     "      */",
\		     "     public ".l:type." get".l:fun_name."() {",
\		     "         return(".l:var.");",
\		     "     }"
\                  ]

:    let l:where = line('.')
:    let l:where = l:where - 1
:    call append(l:where, l:getter)
:endfunction

:map <F11> :call Getter()<cr>

:source ~/.gvimrc
